> ## Documentation Index
> Fetch the complete documentation index at: https://docs.siftstack.com/llms.txt
> Use this file to discover all available pages before exploring further.

# ListJobs

> List jobs.



## OpenAPI

````yaml /openapi.json get /api/v1/jobs
openapi: 3.0.0
info:
  title: Sift API
  version: '1.0'
servers:
  - url: https://api.siftstack.com
    description: Production
  - url: https://gov.api.siftstack.com
    description: Gov
security:
  - BearerAuth: []
tags:
  - name: TagService
    description: Service to programmatically interact with [tags](/glossary#tag).
  - name: CampaignService
  - name: ProtobufDescriptorService
    description: >-
      Service to programmatically interact with protobuf descriptors used for
      protobuf ingestion.
    externalDocs:
      description: Read more about what protobuf ingestion.
      url: /ingestion/protobuf_ingestion
  - name: AnnotationLogService
    description: >-
      Service to programmatically interact with [annotation
      logs](/glossary#annotation).
    externalDocs:
      description: Read more about annotations.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265486685
  - name: MetadataService
  - name: DlqErrorsService
  - name: RuleService
    description: Service to programmatically interact with rules.
    externalDocs:
      description: Read more about what rules are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421102
  - name: WebhookService
  - name: UserDefinedFunctionService
  - name: ReportTemplateService
  - name: RemoteFileService
  - name: PingService
  - name: FamilyService
    description: Service to programmatically interact with family configurations.
  - name: ExternalSyncService
  - name: ReportService
  - name: NotificationService
    description: Service to programmatically interact with in-app notifications.
  - name: ChannelSchemaService
    description: Service to programmatically interact with channel schemas
  - name: IngestService
  - name: UserService
    description: Service to programmatically interact with user objects.
  - name: TestReportService
    description: Service to manage test reports
  - name: PrincipalAttributeService
    description: Service to manage ABAC principal attributes.
  - name: ChannelService
    description: Service to programmatically interact with [channels](/glossary#channel).
    externalDocs:
      description: Read more about what channels are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265453943
  - name: DataImportService
  - name: ExportService
  - name: PolicyService
    description: Service to manage ABAC policies.
  - name: ApiKeyService
  - name: CommentService
    description: >-
      Service to programmatically interact with comments attached to resources
      in the platform.
  - name: JobService
  - name: UserGroupService
  - name: ResourceAttributeService
    description: Service to manage ABAC resource attributes (entity attributes).
  - name: AutomationService
  - name: ViewService
    description: Service to programmatically interact with views.
    externalDocs:
      description: Read more about what views are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/298188809
  - name: UnitService
  - name: DocsService
  - name: RoleService
  - name: SavedSearchService
  - name: RuleEvaluationService
    description: Service to evaluate rules.
    externalDocs:
      description: Read more about what rules are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421102
  - name: RunService
    description: Service to programmatically interact with [runs](/glossary#run).
    externalDocs:
      description: Read more about what runs are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265454053
  - name: PanelConfigurationService
    description: Service to programmatically interact with panel configurations.
  - name: IngestionConfigService
    description: >-
      Service to programmatically interact with [ingestion
      configs](/glossary#ingestion-config).
    externalDocs:
      description: Read more about what ingestion configs are.
      url: /ingestion/creating-amend-ingestion-config
  - name: CalculatedChannelService
  - name: CalculatedChannelsService
    description: Service to programmatically interact with calculated channels.
    externalDocs:
      description: Read more about calculated channels.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421153
  - name: AnnotationService
    description: Service to programmatically interact with annotations.
    externalDocs:
      description: Read more about annotations.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265486685
  - name: DataService
    description: Service to query data
  - name: MeService
  - name: AssetService
    description: Service to programmatically interact with [assets](/glossary#asset).
    externalDocs:
      description: Read more about what assets are.
      url: /data-model
paths:
  /api/v1/jobs:
    get:
      tags:
        - JobService
      summary: ListJobs
      description: List jobs.
      operationId: JobService_ListJobs
      parameters:
        - name: pageSize
          description: >-
            The maximum number of jobs to return. The service may return fewer
            than this value.

            If unspecified, at most 50 jobs will be returned.

            The maximum value is 1000; values above 1000 will be coerced to
            1000. Optional.
          in: query
          required: false
          schema:
            type: integer
            format: int64
        - name: pageToken
          description: >-
            A page token, received from a previous `ListJobs` call.

            Provide this to retrieve the subsequent page.

            When paginating, all other parameters provided to `ListJobs` must
            match

            the call that provided the page token. Optional.
          in: query
          required: false
          schema:
            type: string
        - name: filter
          description: >-
            A [Common Expression Language
            (CEL)](https://github.com/google/cel-spec) filter string.

            Available fields to filter by are:

            `job_id`, `created_by_user_id`, `modified_by_user_id`,
            `created_date`, `modified_date`, `started_date`, `completed_date`,
            and `job_status`

            For further information about how to use CELs, please refer to [this
            guide](https://github.com/google/cel-spec/blob/master/doc/langdef.md#standard-definitions).

            For more information about the fields used for filtering, please
            refer to this definition. Optional.
          in: query
          required: false
          schema:
            type: string
        - name: organizationId
          description: >-
            This field is only required if your user belongs to multiple
            organizations.
          in: query
          required: false
          schema:
            type: string
        - name: orderBy
          description: >-
            How to order the retrieved jobs. Formatted as a comma-separated
            string i.e. "FIELD_NAME[ desc],...".

            Available fields to order_by are `created_date`, `modified_date`,
            `started_date`, `completed_date`, `job_status`.

            If left empty, items are ordered by `created_date` in descending
            order (newest-first).

            For more information about the format of this field, read
            [this](https://google.aip.dev/132#ordering)

            Example: "created_date desc,modified_date"
          in: query
          required: false
          schema:
            type: string
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v1ListJobsResponse'
        default:
          description: An unexpected error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/rpcStatus'
components:
  schemas:
    v1ListJobsResponse:
      type: object
      properties:
        jobs:
          type: array
          items:
            $ref: '#/components/schemas/v1Job'
        nextPageToken:
          type: string
    rpcStatus:
      type: object
      properties:
        code:
          type: integer
          format: int32
        message:
          type: string
        details:
          type: array
          items:
            $ref: '#/components/schemas/protobufAny'
    v1Job:
      type: object
      properties:
        jobId:
          type: string
        organizationId:
          type: string
        createdByUserId:
          type: string
          readOnly: true
        modifiedByUserId:
          type: string
          readOnly: true
        createdDate:
          type: string
          format: date-time
          readOnly: true
        modifiedDate:
          type: string
          format: date-time
          readOnly: true
        startedDate:
          type: string
          format: date-time
          readOnly: true
        completedDate:
          type: string
          format: date-time
          readOnly: true
        jobType:
          $ref: '#/components/schemas/v1JobType'
        jobStatus:
          $ref: '#/components/schemas/v1JobStatus'
        jobStatusDetails:
          $ref: '#/components/schemas/v1JobStatusDetails'
        jobDetails:
          $ref: '#/components/schemas/v1JobDetails'
      required:
        - jobId
        - createdByUserId
        - modifiedByUserId
        - createdDate
        - modifiedDate
        - jobType
        - jobStatus
    protobufAny:
      type: object
      properties:
        '@type':
          type: string
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
    v1JobType:
      type: string
      enum:
        - JOB_TYPE_UNSPECIFIED
        - JOB_TYPE_RULE_EVALUATION
        - JOB_TYPE_DATA_IMPORT
        - JOB_TYPE_DATA_EXPORT
      default: JOB_TYPE_UNSPECIFIED
    v1JobStatus:
      type: string
      enum:
        - JOB_STATUS_UNSPECIFIED
        - JOB_STATUS_CREATED
        - JOB_STATUS_RUNNING
        - JOB_STATUS_FINISHED
        - JOB_STATUS_FAILED
        - JOB_STATUS_CANCELLED
        - JOB_STATUS_CANCEL_REQUESTED
      default: JOB_STATUS_UNSPECIFIED
    v1JobStatusDetails:
      type: object
      properties:
        ruleEvaluation:
          $ref: '#/components/schemas/v1RuleEvaluationStatusDetails'
        dataImport:
          $ref: '#/components/schemas/v1DataImportStatusDetails'
        dataExport:
          $ref: '#/components/schemas/v1DataExportStatusDetails'
    v1JobDetails:
      type: object
      properties:
        ruleEvaluation:
          $ref: '#/components/schemas/v1RuleEvaluationJobDetails'
        dataImport:
          $ref: '#/components/schemas/v1DataImportJobDetails'
        dataExport:
          $ref: '#/components/schemas/v1DataExportJobDetails'
    v1RuleEvaluationStatusDetails:
      type: object
    v1DataImportStatusDetails:
      type: object
      properties:
        pointsProcessed:
          type: string
          format: uint64
        pointsTotal:
          type: string
          format: uint64
      required:
        - pointsProcessed
        - pointsTotal
    v1DataExportStatusDetails:
      type: object
      properties:
        errorMessage:
          type: string
    v1RuleEvaluationJobDetails:
      type: object
      properties:
        reportId:
          type: string
      required:
        - reportId
    v1DataImportJobDetails:
      type: object
      properties:
        dataImportId:
          type: string
      required:
        - dataImportId
    v1DataExportJobDetails:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/v1ExportDataRequest'
        storageKey:
          type: string
    v1ExportDataRequest:
      type: object
      properties:
        timeRange:
          $ref: '#/components/schemas/v1TimeRange'
        runsAndTimeRange:
          $ref: '#/components/schemas/v1RunsAndTimeRange'
        assetsAndTimeRange:
          $ref: '#/components/schemas/v1AssetsAndTimeRange'
        channelIds:
          type: array
          items:
            type: string
        calculatedChannelConfigs:
          type: array
          items:
            $ref: '#/components/schemas/siftexportsv1CalculatedChannelConfig'
        outputFormat:
          $ref: '#/components/schemas/v1ExportOutputFormat'
        exportOptions:
          $ref: '#/components/schemas/v1ExportOptions'
      required:
        - outputFormat
        - exportOptions
    v1TimeRange:
      type: object
      properties:
        startTime:
          type: string
          format: date-time
        stopTime:
          type: string
          format: date-time
      required:
        - startTime
        - stopTime
    v1RunsAndTimeRange:
      type: object
      properties:
        runIds:
          type: array
          items:
            type: string
        startTime:
          type: string
          format: date-time
        stopTime:
          type: string
          format: date-time
      required:
        - runIds
    v1AssetsAndTimeRange:
      type: object
      properties:
        assetIds:
          type: array
          items:
            type: string
        startTime:
          type: string
          format: date-time
        stopTime:
          type: string
          format: date-time
      required:
        - assetIds
        - startTime
        - stopTime
    siftexportsv1CalculatedChannelConfig:
      type: object
      properties:
        name:
          type: string
        expression:
          type: string
        channelReferences:
          type: array
          items:
            $ref: '#/components/schemas/v2CalculatedChannelAbstractChannelReference'
        units:
          type: string
      required:
        - name
        - expression
        - channelReferences
    v1ExportOutputFormat:
      type: string
      enum:
        - EXPORT_OUTPUT_FORMAT_UNSPECIFIED
        - EXPORT_OUTPUT_FORMAT_CSV
        - EXPORT_OUTPUT_FORMAT_SUN
        - EXPORT_OUTPUT_FORMAT_PARQUET
      default: EXPORT_OUTPUT_FORMAT_UNSPECIFIED
    v1ExportOptions:
      type: object
      properties:
        useLegacyFormat:
          type: boolean
          description: >-
            Whether to use legacy format string for channel headers which
            contains key-value metadata.
        simplifyChannelNames:
          type: boolean
          title: >-
            Whether to simplify channel names by removing the component part of
            the name if name is unique in export file
        combineRuns:
          type: boolean
          description: >-
            Whether to combine runs. e.g. channels from the same asset in
            different runs will be combined into a single column of data.
        splitExportByAsset:
          type: boolean
          title: Split each asset into their own export file
        splitExportByRun:
          type: boolean
          title: Split each run into their own export file
        embedChannelConfigs:
          type: boolean
          description: >-
            Embeds a re-importable channel configuration into the export: for
            CSV, as a config row

            inserted immediately after the header row; for Parquet, as
            per-column field metadata

            under the "sift_channel_config" key. Ignored for the SUN output
            format.
    v2CalculatedChannelAbstractChannelReference:
      type: object
      properties:
        channelReference:
          type: string
        channelIdentifier:
          type: string
          title: >-
            must use either a channel_identifier or a
            calculated_channel_reference, not both
        calculatedChannelVersionId:
          type: string
        calculatedChannel:
          $ref: '#/components/schemas/v1ExpressionRequest'
      required:
        - channelReference
    v1ExpressionRequest:
      type: object
      properties:
        channelReferences:
          type: object
          additionalProperties:
            type: string
          description: >-
            A map from the channel reference in the expression string (e.g. $1)
            to the channel id (uuid).

            This is deprecated and should be passed in
            expression_channel_references instead.
        expression:
          type: string
        expressionChannelReferences:
          type: array
          items:
            $ref: '#/components/schemas/v1ExpressionChannelReference'
        functionDependencies:
          type: array
          items:
            $ref: '#/components/schemas/v1FunctionDependency'
      required:
        - expression
    v1ExpressionChannelReference:
      type: object
      properties:
        channelReference:
          type: string
        channelId:
          type: string
        calculatedChannel:
          $ref: '#/components/schemas/v1ExpressionRequest'
      required:
        - channelReference
        - channelId
    v1FunctionDependency:
      type: object
      properties:
        userDefinedFunctionVersionId:
          type: string
      required:
        - userDefinedFunctionVersionId
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````